{$APPTYPE CONSOLE}

uses
  Math;
const
  MAX_N = 1000;
  MAX_M = 5000;
var
  a: array[1..MAX_N] of integer;
  c: array[0..MAX_M, 1..MAX_N] of integer;
  n, m: integer;
  res: integer;
  i, j, k, jj: integer;
begin
  assign(input, 'input.txt');
  reset(input);
  assign(output, 'output.txt');
  rewrite(output);

  read(n, m);
  assert((n >= 1) and (n <= 1000));
  assert((m >= 0) and (m <= 5000));
  for i := 1 to n do
  begin
    assert(not SeekEof(input));
    read(a[i]);
    assert((a[i] >= 0) and (a[i] <= 1000));
  end;
  assert(SeekEof(input));

  FillChar(c, SizeOf(c), 0);
  c[0, 1] := a[1];
  for i := 1 to m do
  begin
    for j := 1 to n do
    begin
      for k := 1 to 6 do
      begin
        jj := (j + k) mod n;
        if (jj = 0) then
          jj := n;
        c[i, jj] := max(c[i, jj], c[i-1, j] + a[jj]);
      end;
    end;
  end;

  res := 0;
  for i := 1 to n do
    res := max(res, c[m, i]);

  write(res);

  close(input);
  close(output);
end.